package sun.nio.ch;

import java.nio.channels.SelectableChannel;
import java.io.IOException;
import java.io.FileDescriptor;

abstract class FileDispatcher extends NativeDispatcher
{
    public static final int NO_LOCK = -1;
    public static final int LOCKED = 0;
    public static final int RET_EX_LOCK = 1;
    public static final int INTERRUPTED = 2;
    
    FileDispatcher() {
    }
    
    abstract long seek(FileDescriptor p0, long p1) throws IOException;
    
    abstract int force(FileDescriptor p0, boolean p1) throws IOException;
    
    abstract int truncate(FileDescriptor p0, long p1) throws IOException;
    
    abstract long size(FileDescriptor p0) throws IOException;
    
    abstract int lock(FileDescriptor p0, boolean p1, long p2, long p3, boolean p4) throws IOException;
    
    abstract void release(FileDescriptor p0, long p1, long p2) throws IOException;
    
    abstract FileDescriptor duplicateForMapping(FileDescriptor p0) throws IOException;
    
    abstract boolean canTransferToDirectly(SelectableChannel p0);
    
    abstract boolean transferToDirectlyNeedsPositionLock();
}
